'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Filename : LED-MATRIX 8*8                                                 '
' Revision : 1.0                                                            '
' Controller : AT90S2313/TINY2313                                           '
' Compiler: BASCOM-AVR 1.11.9.1 DEMO                                        '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'$regfile = "2313def.dat"
$regfile = "attiny2313.dat"

$crystal = 8000000
Config Portb = Output
Config Portd.2 = Output
Config Portd.3 = Output
Config Portd.4 = Output
'Config Portd.5 = Input                                      '  s1
'Config Portd.6 = Input                                      '  s2
'Config Portd.0 = Input                                      '  s3
'Config Portd.1 = Input                                      '  s4


                     '    
'***************************************************************************************
Dim Rnd_a As Byte                                                                                   '
Dim Rnd_b As Byte                                                                                   '
Dim Rnd_c As Byte                                                                                   '  
Dim Rnd_128 As Byte                                                                                 '    0-127


Dim Rd_x As Byte                                                                                    '  X
Dim Rd_y As Byte                                                                                    '  Y
Dim Napravl_x As Byte                                                                               '  X
Dim Napravl_y As Byte                                                                               '  Y
Dim Speed_x As Byte                                                                                 '  X
Dim Speed_y As Byte                                                                                 '  Y
Dim X As Byte
Dim Y As Byte
Dim Temp As Byte
Dim Delta As Byte                                                                                   '
Dim Flgdelta As Byte
Delta = 10

Dim Effect As Byte
Effect = 1
Dim Flg_rotatespeed As Byte

'Rd_x = 1
'Rd_y = 1
'Speed_x = 120
'Speed_y = 240



Readeeprom Rnd_a , 3
Readeeprom Rnd_b , 4
Readeeprom Rnd_c , 5

If Rnd_a = 0 And Rnd_b = 0 And Rnd_c = 0 Then
   Rnd_a = 123 : Rnd_b = 23 : Rnd_c = 17                                                            ' . ,  0
End If

For Temp = 0 To Rnd_128
   Gosub Rnd_byte
Next Temp

Writeeeprom Rnd_a , 5
Writeeeprom Rnd_b , 3
Writeeeprom Rnd_c , 4

Gosub Neweffects_x
Gosub Neweffects_y


Do


   '  7- 

   If Rd_x.0 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H00
   Waitus Delta

   If Rd_x.1 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H04
   Waitus Delta

   If Rd_x.2 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H08
   Waitus Delta

   If Rd_x.3 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H0C
   Waitus Delta

   If Rd_x.4 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H10
   Waitus Delta

   If Rd_x.5 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H14
   Waitus Delta

   If Rd_x.6 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H18
   Waitus Delta

   If Rd_x.7 = 1 Then
      Portb = Rd_y                                                                                  '  
   Else
      Portb = 0
   End If
   Portd = &H1C
   Waitus Delta


   Incr X
   If X >= Speed_x Then
      X = 0
      If Napravl_x = 1 Then
         Rotate Rd_x , Left
      Else
         Rotate Rd_x , Right
      End If

      Gosub Rnd_byte
      If Rnd_128 = 27 Then Gosub Neweffects_x

      Gosub Speed

   End If

   Incr Y
   If Y >= Speed_y Then
      Y = 0
      If Napravl_y = 1 Then
         Rotate Rd_y , Left
      Else
         Rotate Rd_y , Right
      End If

      Gosub Rnd_byte
      If Rnd_128 = 16 Then Gosub Neweffects_y

      Gosub Speed
   End If

Loop
'

'
Neweffects_x:
   Gosub Rnd_byte
   Rd_x = Rnd_c
   If Rd_y < 85 Then Rd_x = Rnd_b
   If Rd_y > 170 Then Rd_x = Rnd_a

   If Rd_x = 0 Then Rd_x = 1
   If Rd_x = 255 Then Rd_x = 1

    Rd_x = 17

   Speed_x = Rnd_128
   Speed_x = Speed_x + 20

   If Rnd_128 < 64 Then
      Napravl_x = 0
   Else
      Napravl_x = 1
   End If
Return

Neweffects_y:
   Gosub Rnd_byte
   Rd_y = Rnd_c
   If Rd_x < 85 Then Rd_y = Rnd_b
   If Rd_x > 170 Then Rd_y = Rnd_a

   If Rd_y = 0 Then Rd_y = 1
   If Rd_y = 255 Then Rd_y = 1

   Speed_y = Rnd_128
   Speed_y = Speed_y + 20

   If Rnd_128 < 64 Then
      Napravl_y = 0
   Else
      Napravl_y = 1
   End If
Return


Speed:
   If Flg_rotatespeed = 0 Then
      Incr Delta
      If Delta > 250 Then Flg_rotatespeed = 1
   Else
      Decr Delta
      If Delta < 15 Then Flg_rotatespeed = 0
   End If

Return



'==========  ==========
'***************************************************************************************
Rnd_byte:
   $asm
      Lds R16 , {Rnd_a}                                                                             '
      Lds R17 , {Rnd_b}
      Lds R18 , {Rnd_c}
      Mov R16 , R17                                                                                 'A=B
      Mov R17 , R18                                                                                 'B=C
      Lsl R17                                                                                       'B<<1
      Brcc _Null
      Sbr R17 , 1                                                                                   ' "1"  D1  7     "1"
_null:
      Mov R18 , R16                                                                                 '=B+A
      Add R18 , R17                                                                                 '-||-
      Sts {Rnd_a} , R16                                                                             '
      Sts {Rnd_b} , R17
      Sts {Rnd_c} , R18
      '   ,     0-127:
      'cbr r18, $80
      '   :
      lsr r18
      Sts {Rnd_128} , R18                                                                           '    0-127
   $end Asm
Return



X_data:
   Data 1 , 1 , 1 , 1

Y_data:
   Data 0 , 0 , 0 , 0

Speders:
   Data 1 , 2 , 3 , 4 , 6 , 9 , 13 , 18 , 24 , 31 , 39 , 50 , 70 , 50 , 39 , 31 , 24 , 18 , 13 , 9 , 6 , 4 , 3 , 2 , 1